BM_TIME_ID = "BM_Time_";
function BM_Time_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	PLUG_IN_FRAME = "BM_Time";
	PLUG_IN_NAME = "BM Time";
	BM_ICON_SIZE = BM_TIME_ICON_SIZE;
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME, BM_ICON_SIZE, BM_TIME_ID);
end

function BM_Time_OnEvent(event)	
	if (event == "VARIABLES_LOADED") then		
		BM_Time_initialize();
		return;
	end
end

function BM_Time_initialize()
	if (not BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS]) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS] = {};
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_minute_offset == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_minute_offset = 0;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_hour_offset == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_hour_offset = 0;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_ShowIcon == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_ShowIcon = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_ShowLabel == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_ShowLabel = true;
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_24hours == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_24hours = false;
	end
	BM_HOUR_OFFSET = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_hour_offset;
	BM_MINUTE_OFFSET = BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_minute_offset;
	BM_Time_OnShow();
end

function BM_Time_OnUpdate(arg1)
	BM_TIME_REFRESH = BM_TIME_REFRESH + arg1;
	BM_TOTAL_TIME_FOR_LEVEL = BM_TOTAL_TIME_FOR_LEVEL + arg1;
	BM_TOTAL_TIME = BM_TOTAL_TIME + arg1;
	if (BM_TIME_REFRESH > BM_TIME_DELAY) then
		BM_TIME_REFRESH = 0.0;
		BM_Time_Refresh();
	end
end

function BM_Time_Refresh()
	-- Creates a clock frame.
	local HOUR, MINUTE = GetGameTime();
	local PM = 0;
	local time_Text = "";
	MINUTE = MINUTE + BM_MINUTE_OFFSET;
	HOUR = HOUR + BM_HOUR_OFFSET;
	local time = (HOUR*60)+MINUTE;
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_24hours) then
		if (MINUTE > 59) then
			MINUTE = MINUTE - 60;
			HOUR = HOUR + 1
		elseif (MINUTE < 0) then
			MINUTE = 60 + MINUTE;
			HOUR = HOUR - 1;
		end
		if (HOUR > 23) then
			HOUR = HOUR - 24;
		elseif (HOUR < 0) then
			HOUR = 24 + HOUR;
		end
		BM_TimeText:SetText(format(TEXT(TIME_TWENTYFOURHOURS), HOUR, MINUTE));
	else
		if (MINUTE > 59) then
			MINUTE = MINUTE - 60;
			HOUR = HOUR + 1
		elseif (MINUTE < 0) then
			MINUTE = 60 + MINUTE;
			HOUR = HOUR - 1;
		end
		if (HOUR > 23) then
			HOUR = HOUR - 24;
		elseif (HOUR < 0) then
			HOUR = 24 + HOUR;
		end
		
		if(HOUR >= 12) then
			PM = 1;
		end
		if(HOUR > 12) then
			HOUR = HOUR - 12;
		end
		if(HOUR == 0) then
			HOUR = 12;
		end	
		if(PM == 0) then
			BM_TimeText:SetText(format(TEXT(TIME_TWELVEHOURAM), HOUR, MINUTE));
			BM_TimeText:SetTextColor(1.0, 1.0, 1.0, 1.0);
		else
			BM_TimeText:SetText(format(TEXT(TIME_TWELVEHOURPM), HOUR, MINUTE));
			BM_TimeText:SetTextColor(1.0, 1.0, 1.0, 1.0);
		end
	end
	if(time == GAMETIME_DAWN) then
		BM_Time_SetIcon();
	elseif(time == GAMETIME_DUSK) then
		BM_Time_SetIcon();
	end
	return;
end

function BM_Time_Refresh_ToolTip()
	BM_TIME_TOOLTIP_TEXT = "" ..
			format(BM_TIME_TOOLTIP_TEXT3, UnitLevel("player")) .. "\n" .. 
			format(BM_TIME_TOOLTIP_TEXT1, BM_GetTime(BM_TOTAL_TIME)) .."\n" ..
			format(BM_TIME_TOOLTIP_TEXT2, BM_GetTime(BM_TOTAL_TIME_FOR_LEVEL)) .. "\n" ..
			format(BM_TIME_TOOLTIP_TEXT4, BM_GetTime((BM_TOTAL_TIME/UnitLevel("player"))));
end

function BM_Time_OnShow()
	BM_Time_SetIcon();
end

function BM_Time_SetIcon()
	local hour, minute = GetGameTime();
	local time = (hour+BM_HOUR_OFFSET)*60 + (minute+BM_MINUTE_OFFSET);
	local icon = BM_TimeIcon;
	if (TitanGetVar(BM_TIME_ID, "ShowIcon")) then
		if(time < GAMETIME_DAWN or time >= GAMETIME_DUSK) then
			icon:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Icon_night");
			icon:SetWidth(BM_TIME_ICON_SIZE);
			icon:SetHeight(BM_TIME_ICON_SIZE);
		else
			icon:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Icon_day");
			icon:SetWidth(BM_TIME_ICON_SIZE);
			icon:SetHeight(BM_TIME_ICON_SIZE);
		end
	else
		icon:SetTexture("");
		icon:SetWidth(1);
	end
end

function BM_Time_OnEnter()
	BM_Time_Refresh_ToolTip();
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	-- set the tool tip text
	GameTooltip:SetText(BM_TIME_TOOLTIP_TITLE);
	BM_Tooltip_AddTooltipText(BM_TIME_TOOLTIP_TEXT);
	GameTooltip:Show();
end

function BM_Time_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end

--Time options
local BMTime_Sliders = {};
local BMTime_CheckButtons = {};
local ctext1 = BM_SHOW_ICON;
local ctext2 = BM_SHOW_LABEL;
local ctext3 = BM_TIME_24_MODE;
local stext1 = BM_TIME_HOUROFFSET;
local stext2 = BM_TIME_MINUTEOFFSET;
BMTime_CheckButtons[ctext1] = {
	id = 1,
	strVar = "BM_Time_ShowIcon",
	pSlashCommand = "BMTime_Check1_Opt"
};
BMTime_CheckButtons[ctext2] = {
	id = 2, 
	strVar = "BM_Time_ShowLabel",
	pSlashCommand = "BMTime_Check2_Opt"
};
BMTime_CheckButtons[ctext3] = {
	id = 3, 
	strVar = "BM_24hours",
	pSlashCommand = "BMTime_24hours_Opt"
};
BMTime_Sliders[stext1] = {
	id = 1,
	strVar = "BM_Time_hour_offset",
	pSlashCommand = "BM_HourOffset_SlashHandler",
	minValue = -12,
	maxValue = 12,
	valueStep = 1,
	minText="-12",
	maxText="+12",
};
BMTime_Sliders[stext2] = {
	id = 2,
	strVar = "BM_Time_minute_offset",
	pSlashCommand = "BM_MinuteOffset_SlashHandler",
	minValue = -30,
	maxValue = 30,
	valueStep = 1,
	minText="-30",
	maxText="+30",
};

function BMTime_Check1_Opt(msg)
	TitanSetVar(BM_TIME_ID, "ShowIcon", msg);
	BM_Time_SetIcon();
end

function BMTime_Check2_Opt(msg)
	
end

function BMTime_24hours_Opt(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_24hours = msg;
end

function BM_HourOffset_SlashHandler(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_hour_offset = msg;
	BM_HOUR_OFFSET = msg;
	BM_Time_SetIcon();
end

function BM_MinuteOffset_SlashHandler(msg)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS].BM_Time_minute_offset = msg;
	BM_MINUTE_OFFSET = msg;
	BM_Time_SetIcon();
end

function BM_Time_RefreshOptions()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BMTime_CheckButtons do
		button = getglobal("BMTime_Check" .. value.id);
		string = getglobal("BMTime_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = getglobal(value.pSlashCommand);
	end
	local slider, string, low, high;
	--  Setup Sliders
	for key, value in BMTime_Sliders do
		slider = getglobal("BMTime_Slider"..value.id);
		string = getglobal("BMTime_Slider"..value.id.."Text");
		low = getglobal("BMTime_Slider"..value.id.."Low");
		high = getglobal("BMTime_Slider"..value.id.."High");
		
		slider.id = value.id;
		slider.strVar = value.strVar;
		slider.pSlashCommand = getglobal(value.pSlashCommand);
				
		--OptionsFrame_EnableSlider(slider);
		slider:SetMinMaxValues(value.minValue, value.maxValue);
		slider:SetValueStep(value.valueStep);
		slider:SetValue(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][value.strVar]);
		string:SetText(key);
		low:SetText(value.minText);
		high:SetText(value.maxText);
	end
end